import { defineStore } from 'pinia'
import { v4 as uuidv4 } from 'uuid'
import { fromBase64 } from '../common/base64'

export const useChannelStore = defineStore({
  id: 'channelStore',
  state: () => ({
    channels: [
      {
        id: 'a798423c-3fbf-434d-9a00-57d7642bff65',
        name: 'Default',
        key: 'AAAAAAAAAAAAAAAAAAAAAA==',
        rawKey: new Uint8Array(16)
      }
    ]
  }),
  getters: {
    getChannelById: (state) => {
      return (channelId) => state.channels.find((channel) => channel.id === channelId)
    }
  },
  actions: {
    addChannel(name, key) {
      this.channels.push({
        id: uuidv4(),
        name: name,
        key: key,
        rawKey: fromBase64(key)
      })
    }
  }
})